Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/2.5.0/ALGLIB-2.5.0/sblas.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/2.5.0/ALGLIB-2.5.0/sblas.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/2.5.0/ALGLIB-2.5.0/sblas.cs	(revision 4068)
@@ -25,202 +25,172 @@
 *************************************************************************/
 
-using System;
 
-namespace alglib
-{
-    public class sblas
-    {
-        public static void symmetricmatrixvectormultiply(ref double[,] a,
-            bool isupper,
-            int i1,
-            int i2,
-            ref double[] x,
-            double alpha,
-            ref double[] y)
-        {
-            int i = 0;
-            int ba1 = 0;
-            int ba2 = 0;
-            int by1 = 0;
-            int by2 = 0;
-            int bx1 = 0;
-            int bx2 = 0;
-            int n = 0;
-            double v = 0;
-            int i_ = 0;
-            int i1_ = 0;
+namespace alglib {
+  public class sblas {
+    public static void symmetricmatrixvectormultiply(ref double[,] a,
+        bool isupper,
+        int i1,
+        int i2,
+        ref double[] x,
+        double alpha,
+        ref double[] y) {
+      int i = 0;
+      int ba1 = 0;
+      int ba2 = 0;
+      int by1 = 0;
+      int by2 = 0;
+      int bx1 = 0;
+      int bx2 = 0;
+      int n = 0;
+      double v = 0;
+      int i_ = 0;
+      int i1_ = 0;
 
-            n = i2-i1+1;
-            if( n<=0 )
-            {
-                return;
-            }
-            
-            //
-            // Let A = L + D + U, where
-            //  L is strictly lower triangular (main diagonal is zero)
-            //  D is diagonal
-            //  U is strictly upper triangular (main diagonal is zero)
-            //
-            // A*x = L*x + D*x + U*x
-            //
-            // Calculate D*x first
-            //
-            for(i=i1; i<=i2; i++)
-            {
-                y[i-i1+1] = a[i,i]*x[i-i1+1];
-            }
-            
-            //
-            // Add L*x + U*x
-            //
-            if( isupper )
-            {
-                for(i=i1; i<=i2-1; i++)
-                {
-                    
-                    //
-                    // Add L*x to the result
-                    //
-                    v = x[i-i1+1];
-                    by1 = i-i1+2;
-                    by2 = n;
-                    ba1 = i+1;
-                    ba2 = i2;
-                    i1_ = (ba1) - (by1);
-                    for(i_=by1; i_<=by2;i_++)
-                    {
-                        y[i_] = y[i_] + v*a[i,i_+i1_];
-                    }
-                    
-                    //
-                    // Add U*x to the result
-                    //
-                    bx1 = i-i1+2;
-                    bx2 = n;
-                    ba1 = i+1;
-                    ba2 = i2;
-                    i1_ = (ba1)-(bx1);
-                    v = 0.0;
-                    for(i_=bx1; i_<=bx2;i_++)
-                    {
-                        v += x[i_]*a[i,i_+i1_];
-                    }
-                    y[i-i1+1] = y[i-i1+1]+v;
-                }
-            }
-            else
-            {
-                for(i=i1+1; i<=i2; i++)
-                {
-                    
-                    //
-                    // Add L*x to the result
-                    //
-                    bx1 = 1;
-                    bx2 = i-i1;
-                    ba1 = i1;
-                    ba2 = i-1;
-                    i1_ = (ba1)-(bx1);
-                    v = 0.0;
-                    for(i_=bx1; i_<=bx2;i_++)
-                    {
-                        v += x[i_]*a[i,i_+i1_];
-                    }
-                    y[i-i1+1] = y[i-i1+1]+v;
-                    
-                    //
-                    // Add U*x to the result
-                    //
-                    v = x[i-i1+1];
-                    by1 = 1;
-                    by2 = i-i1;
-                    ba1 = i1;
-                    ba2 = i-1;
-                    i1_ = (ba1) - (by1);
-                    for(i_=by1; i_<=by2;i_++)
-                    {
-                        y[i_] = y[i_] + v*a[i,i_+i1_];
-                    }
-                }
-            }
-            for(i_=1; i_<=n;i_++)
-            {
-                y[i_] = alpha*y[i_];
-            }
+      n = i2 - i1 + 1;
+      if (n <= 0) {
+        return;
+      }
+
+      //
+      // Let A = L + D + U, where
+      //  L is strictly lower triangular (main diagonal is zero)
+      //  D is diagonal
+      //  U is strictly upper triangular (main diagonal is zero)
+      //
+      // A*x = L*x + D*x + U*x
+      //
+      // Calculate D*x first
+      //
+      for (i = i1; i <= i2; i++) {
+        y[i - i1 + 1] = a[i, i] * x[i - i1 + 1];
+      }
+
+      //
+      // Add L*x + U*x
+      //
+      if (isupper) {
+        for (i = i1; i <= i2 - 1; i++) {
+
+          //
+          // Add L*x to the result
+          //
+          v = x[i - i1 + 1];
+          by1 = i - i1 + 2;
+          by2 = n;
+          ba1 = i + 1;
+          ba2 = i2;
+          i1_ = (ba1) - (by1);
+          for (i_ = by1; i_ <= by2; i_++) {
+            y[i_] = y[i_] + v * a[i, i_ + i1_];
+          }
+
+          //
+          // Add U*x to the result
+          //
+          bx1 = i - i1 + 2;
+          bx2 = n;
+          ba1 = i + 1;
+          ba2 = i2;
+          i1_ = (ba1) - (bx1);
+          v = 0.0;
+          for (i_ = bx1; i_ <= bx2; i_++) {
+            v += x[i_] * a[i, i_ + i1_];
+          }
+          y[i - i1 + 1] = y[i - i1 + 1] + v;
         }
+      } else {
+        for (i = i1 + 1; i <= i2; i++) {
+
+          //
+          // Add L*x to the result
+          //
+          bx1 = 1;
+          bx2 = i - i1;
+          ba1 = i1;
+          ba2 = i - 1;
+          i1_ = (ba1) - (bx1);
+          v = 0.0;
+          for (i_ = bx1; i_ <= bx2; i_++) {
+            v += x[i_] * a[i, i_ + i1_];
+          }
+          y[i - i1 + 1] = y[i - i1 + 1] + v;
+
+          //
+          // Add U*x to the result
+          //
+          v = x[i - i1 + 1];
+          by1 = 1;
+          by2 = i - i1;
+          ba1 = i1;
+          ba2 = i - 1;
+          i1_ = (ba1) - (by1);
+          for (i_ = by1; i_ <= by2; i_++) {
+            y[i_] = y[i_] + v * a[i, i_ + i1_];
+          }
+        }
+      }
+      for (i_ = 1; i_ <= n; i_++) {
+        y[i_] = alpha * y[i_];
+      }
+    }
 
 
-        public static void symmetricrank2update(ref double[,] a,
-            bool isupper,
-            int i1,
-            int i2,
-            ref double[] x,
-            ref double[] y,
-            ref double[] t,
-            double alpha)
-        {
-            int i = 0;
-            int tp1 = 0;
-            int tp2 = 0;
-            double v = 0;
-            int i_ = 0;
-            int i1_ = 0;
+    public static void symmetricrank2update(ref double[,] a,
+        bool isupper,
+        int i1,
+        int i2,
+        ref double[] x,
+        ref double[] y,
+        ref double[] t,
+        double alpha) {
+      int i = 0;
+      int tp1 = 0;
+      int tp2 = 0;
+      double v = 0;
+      int i_ = 0;
+      int i1_ = 0;
 
-            if( isupper )
-            {
-                for(i=i1; i<=i2; i++)
-                {
-                    tp1 = i+1-i1;
-                    tp2 = i2-i1+1;
-                    v = x[i+1-i1];
-                    for(i_=tp1; i_<=tp2;i_++)
-                    {
-                        t[i_] = v*y[i_];
-                    }
-                    v = y[i+1-i1];
-                    for(i_=tp1; i_<=tp2;i_++)
-                    {
-                        t[i_] = t[i_] + v*x[i_];
-                    }
-                    for(i_=tp1; i_<=tp2;i_++)
-                    {
-                        t[i_] = alpha*t[i_];
-                    }
-                    i1_ = (tp1) - (i);
-                    for(i_=i; i_<=i2;i_++)
-                    {
-                        a[i,i_] = a[i,i_] + t[i_+i1_];
-                    }
-                }
-            }
-            else
-            {
-                for(i=i1; i<=i2; i++)
-                {
-                    tp1 = 1;
-                    tp2 = i+1-i1;
-                    v = x[i+1-i1];
-                    for(i_=tp1; i_<=tp2;i_++)
-                    {
-                        t[i_] = v*y[i_];
-                    }
-                    v = y[i+1-i1];
-                    for(i_=tp1; i_<=tp2;i_++)
-                    {
-                        t[i_] = t[i_] + v*x[i_];
-                    }
-                    for(i_=tp1; i_<=tp2;i_++)
-                    {
-                        t[i_] = alpha*t[i_];
-                    }
-                    i1_ = (tp1) - (i1);
-                    for(i_=i1; i_<=i;i_++)
-                    {
-                        a[i,i_] = a[i,i_] + t[i_+i1_];
-                    }
-                }
-            }
+      if (isupper) {
+        for (i = i1; i <= i2; i++) {
+          tp1 = i + 1 - i1;
+          tp2 = i2 - i1 + 1;
+          v = x[i + 1 - i1];
+          for (i_ = tp1; i_ <= tp2; i_++) {
+            t[i_] = v * y[i_];
+          }
+          v = y[i + 1 - i1];
+          for (i_ = tp1; i_ <= tp2; i_++) {
+            t[i_] = t[i_] + v * x[i_];
+          }
+          for (i_ = tp1; i_ <= tp2; i_++) {
+            t[i_] = alpha * t[i_];
+          }
+          i1_ = (tp1) - (i);
+          for (i_ = i; i_ <= i2; i_++) {
+            a[i, i_] = a[i, i_] + t[i_ + i1_];
+          }
         }
+      } else {
+        for (i = i1; i <= i2; i++) {
+          tp1 = 1;
+          tp2 = i + 1 - i1;
+          v = x[i + 1 - i1];
+          for (i_ = tp1; i_ <= tp2; i_++) {
+            t[i_] = v * y[i_];
+          }
+          v = y[i + 1 - i1];
+          for (i_ = tp1; i_ <= tp2; i_++) {
+            t[i_] = t[i_] + v * x[i_];
+          }
+          for (i_ = tp1; i_ <= tp2; i_++) {
+            t[i_] = alpha * t[i_];
+          }
+          i1_ = (tp1) - (i1);
+          for (i_ = i1; i_ <= i; i_++) {
+            a[i, i_] = a[i, i_] + t[i_ + i1_];
+          }
+        }
+      }
     }
+  }
 }
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/2.5.0/ALGLIB-2.5.0/schur.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/2.5.0/ALGLIB-2.5.0/schur.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/2.5.0/ALGLIB-2.5.0/schur.cs	(revision 4068)
@@ -25,104 +25,96 @@
 *************************************************************************/
 
-using System;
 
-namespace alglib
-{
-    public class schur
-    {
-        /*************************************************************************
-        Subroutine performing the Schur decomposition of a general matrix by using
-        the QR algorithm with multiple shifts.
+namespace alglib {
+  public class schur {
+    /*************************************************************************
+    Subroutine performing the Schur decomposition of a general matrix by using
+    the QR algorithm with multiple shifts.
 
-        The source matrix A is represented as S'*A*S = T, where S is an orthogonal
-        matrix (Schur vectors), T - upper quasi-triangular matrix (with blocks of
-        sizes 1x1 and 2x2 on the main diagonal).
+    The source matrix A is represented as S'*A*S = T, where S is an orthogonal
+    matrix (Schur vectors), T - upper quasi-triangular matrix (with blocks of
+    sizes 1x1 and 2x2 on the main diagonal).
 
-        Input parameters:
-            A   -   matrix to be decomposed.
-                    Array whose indexes range within [0..N-1, 0..N-1].
-            N   -   size of A, N>=0.
+    Input parameters:
+        A   -   matrix to be decomposed.
+                Array whose indexes range within [0..N-1, 0..N-1].
+        N   -   size of A, N>=0.
 
 
-        Output parameters:
-            A   -   contains matrix T.
-                    Array whose indexes range within [0..N-1, 0..N-1].
-            S   -   contains Schur vectors.
-                    Array whose indexes range within [0..N-1, 0..N-1].
+    Output parameters:
+        A   -   contains matrix T.
+                Array whose indexes range within [0..N-1, 0..N-1].
+        S   -   contains Schur vectors.
+                Array whose indexes range within [0..N-1, 0..N-1].
 
-        Note 1:
-            The block structure of matrix T can be easily recognized: since all
-            the elements below the blocks are zeros, the elements a[i+1,i] which
-            are equal to 0 show the block border.
+    Note 1:
+        The block structure of matrix T can be easily recognized: since all
+        the elements below the blocks are zeros, the elements a[i+1,i] which
+        are equal to 0 show the block border.
 
-        Note 2:
-            The algorithm performance depends on the value of the internal parameter
-            NS of the InternalSchurDecomposition subroutine which defines the number
-            of shifts in the QR algorithm (similarly to the block width in block-matrix
-            algorithms in linear algebra). If you require maximum performance on
-            your machine, it is recommended to adjust this parameter manually.
+    Note 2:
+        The algorithm performance depends on the value of the internal parameter
+        NS of the InternalSchurDecomposition subroutine which defines the number
+        of shifts in the QR algorithm (similarly to the block width in block-matrix
+        algorithms in linear algebra). If you require maximum performance on
+        your machine, it is recommended to adjust this parameter manually.
 
-        Result:
-            True,
-                if the algorithm has converged and parameters A and S contain the result.
-            False,
-                if the algorithm has not converged.
+    Result:
+        True,
+            if the algorithm has converged and parameters A and S contain the result.
+        False,
+            if the algorithm has not converged.
 
-        Algorithm implemented on the basis of the DHSEQR subroutine (LAPACK 3.0 library).
-        *************************************************************************/
-        public static bool rmatrixschur(ref double[,] a,
-            int n,
-            ref double[,] s)
-        {
-            bool result = new bool();
-            double[] tau = new double[0];
-            double[] wi = new double[0];
-            double[] wr = new double[0];
-            double[,] a1 = new double[0,0];
-            double[,] s1 = new double[0,0];
-            int info = 0;
-            int i = 0;
-            int j = 0;
+    Algorithm implemented on the basis of the DHSEQR subroutine (LAPACK 3.0 library).
+    *************************************************************************/
+    public static bool rmatrixschur(ref double[,] a,
+        int n,
+        ref double[,] s) {
+      bool result = new bool();
+      double[] tau = new double[0];
+      double[] wi = new double[0];
+      double[] wr = new double[0];
+      double[,] a1 = new double[0, 0];
+      double[,] s1 = new double[0, 0];
+      int info = 0;
+      int i = 0;
+      int j = 0;
 
-            
-            //
-            // Upper Hessenberg form of the 0-based matrix
-            //
-            ortfac.rmatrixhessenberg(ref a, n, ref tau);
-            ortfac.rmatrixhessenbergunpackq(ref a, n, ref tau, ref s);
-            
-            //
-            // Convert from 0-based arrays to 1-based,
-            // then call InternalSchurDecomposition
-            // Awkward, of course, but Schur decompisiton subroutine
-            // is too complex to fix it.
-            //
-            //
-            a1 = new double[n+1, n+1];
-            s1 = new double[n+1, n+1];
-            for(i=1; i<=n; i++)
-            {
-                for(j=1; j<=n; j++)
-                {
-                    a1[i,j] = a[i-1,j-1];
-                    s1[i,j] = s[i-1,j-1];
-                }
-            }
-            hsschur.internalschurdecomposition(ref a1, n, 1, 1, ref wr, ref wi, ref s1, ref info);
-            result = info==0;
-            
-            //
-            // convert from 1-based arrays to -based
-            //
-            for(i=1; i<=n; i++)
-            {
-                for(j=1; j<=n; j++)
-                {
-                    a[i-1,j-1] = a1[i,j];
-                    s[i-1,j-1] = s1[i,j];
-                }
-            }
-            return result;
+
+      //
+      // Upper Hessenberg form of the 0-based matrix
+      //
+      ortfac.rmatrixhessenberg(ref a, n, ref tau);
+      ortfac.rmatrixhessenbergunpackq(ref a, n, ref tau, ref s);
+
+      //
+      // Convert from 0-based arrays to 1-based,
+      // then call InternalSchurDecomposition
+      // Awkward, of course, but Schur decompisiton subroutine
+      // is too complex to fix it.
+      //
+      //
+      a1 = new double[n + 1, n + 1];
+      s1 = new double[n + 1, n + 1];
+      for (i = 1; i <= n; i++) {
+        for (j = 1; j <= n; j++) {
+          a1[i, j] = a[i - 1, j - 1];
+          s1[i, j] = s[i - 1, j - 1];
         }
+      }
+      hsschur.internalschurdecomposition(ref a1, n, 1, 1, ref wr, ref wi, ref s1, ref info);
+      result = info == 0;
+
+      //
+      // convert from 1-based arrays to -based
+      //
+      for (i = 1; i <= n; i++) {
+        for (j = 1; j <= n; j++) {
+          a[i - 1, j - 1] = a1[i, j];
+          s[i - 1, j - 1] = s1[i, j];
+        }
+      }
+      return result;
     }
+  }
 }
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/2.5.0/ALGLIB-2.5.0/sdet.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/2.5.0/ALGLIB-2.5.0/sdet.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/2.5.0/ALGLIB-2.5.0/sdet.cs	(revision 4068)
@@ -19,167 +19,138 @@
 *************************************************************************/
 
-using System;
 
-namespace alglib
-{
-    public class sdet
-    {
-        /*************************************************************************
-        Determinant calculation of the matrix given by LDLT decomposition.
+namespace alglib {
+  public class sdet {
+    /*************************************************************************
+    Determinant calculation of the matrix given by LDLT decomposition.
 
-        Input parameters:
-            A       -   LDLT-decomposition of the matrix,
-                        output of subroutine SMatrixLDLT.
-            Pivots  -   table of permutations which were made during
-                        LDLT decomposition, output of subroutine SMatrixLDLT.
-            N       -   size of matrix A.
-            IsUpper -   matrix storage format. The value is equal to the input
-                        parameter of subroutine SMatrixLDLT.
+    Input parameters:
+        A       -   LDLT-decomposition of the matrix,
+                    output of subroutine SMatrixLDLT.
+        Pivots  -   table of permutations which were made during
+                    LDLT decomposition, output of subroutine SMatrixLDLT.
+        N       -   size of matrix A.
+        IsUpper -   matrix storage format. The value is equal to the input
+                    parameter of subroutine SMatrixLDLT.
 
-        Result:
-            matrix determinant.
+    Result:
+        matrix determinant.
 
-          -- ALGLIB --
-             Copyright 2005-2008 by Bochkanov Sergey
-        *************************************************************************/
-        public static double smatrixldltdet(ref double[,] a,
-            ref int[] pivots,
-            int n,
-            bool isupper)
-        {
-            double result = 0;
-            int k = 0;
+      -- ALGLIB --
+         Copyright 2005-2008 by Bochkanov Sergey
+    *************************************************************************/
+    public static double smatrixldltdet(ref double[,] a,
+        ref int[] pivots,
+        int n,
+        bool isupper) {
+      double result = 0;
+      int k = 0;
 
-            result = 1;
-            if( isupper )
-            {
-                k = 0;
-                while( k<n )
-                {
-                    if( pivots[k]>=0 )
-                    {
-                        result = result*a[k,k];
-                        k = k+1;
-                    }
-                    else
-                    {
-                        result = result*(a[k,k]*a[k+1,k+1]-a[k,k+1]*a[k,k+1]);
-                        k = k+2;
-                    }
-                }
-            }
-            else
-            {
-                k = n-1;
-                while( k>=0 )
-                {
-                    if( pivots[k]>=0 )
-                    {
-                        result = result*a[k,k];
-                        k = k-1;
-                    }
-                    else
-                    {
-                        result = result*(a[k-1,k-1]*a[k,k]-a[k,k-1]*a[k,k-1]);
-                        k = k-2;
-                    }
-                }
-            }
-            return result;
+      result = 1;
+      if (isupper) {
+        k = 0;
+        while (k < n) {
+          if (pivots[k] >= 0) {
+            result = result * a[k, k];
+            k = k + 1;
+          } else {
+            result = result * (a[k, k] * a[k + 1, k + 1] - a[k, k + 1] * a[k, k + 1]);
+            k = k + 2;
+          }
         }
+      } else {
+        k = n - 1;
+        while (k >= 0) {
+          if (pivots[k] >= 0) {
+            result = result * a[k, k];
+            k = k - 1;
+          } else {
+            result = result * (a[k - 1, k - 1] * a[k, k] - a[k, k - 1] * a[k, k - 1]);
+            k = k - 2;
+          }
+        }
+      }
+      return result;
+    }
 
 
-        /*************************************************************************
-        Determinant calculation of the symmetric matrix
+    /*************************************************************************
+    Determinant calculation of the symmetric matrix
 
-        Input parameters:
-            A       -   matrix. Array with elements [0..N-1, 0..N-1].
-            N       -   size of matrix A.
-            IsUpper -   if IsUpper = True, then symmetric matrix A is given by its
-                        upper triangle, and the lower triangle isnt used by
-                        subroutine. Similarly, if IsUpper = False, then A is given
-                        by its lower triangle.
+    Input parameters:
+        A       -   matrix. Array with elements [0..N-1, 0..N-1].
+        N       -   size of matrix A.
+        IsUpper -   if IsUpper = True, then symmetric matrix A is given by its
+                    upper triangle, and the lower triangle isnt used by
+                    subroutine. Similarly, if IsUpper = False, then A is given
+                    by its lower triangle.
 
-        Result:
-            determinant of matrix A.
+    Result:
+        determinant of matrix A.
 
-          -- ALGLIB --
-             Copyright 2005-2008 by Bochkanov Sergey
-        *************************************************************************/
-        public static double smatrixdet(double[,] a,
-            int n,
-            bool isupper)
-        {
-            double result = 0;
-            int[] pivots = new int[0];
+      -- ALGLIB --
+         Copyright 2005-2008 by Bochkanov Sergey
+    *************************************************************************/
+    public static double smatrixdet(double[,] a,
+        int n,
+        bool isupper) {
+      double result = 0;
+      int[] pivots = new int[0];
 
-            a = (double[,])a.Clone();
+      a = (double[,])a.Clone();
 
-            ldlt.smatrixldlt(ref a, n, isupper, ref pivots);
-            result = smatrixldltdet(ref a, ref pivots, n, isupper);
-            return result;
-        }
+      ldlt.smatrixldlt(ref a, n, isupper, ref pivots);
+      result = smatrixldltdet(ref a, ref pivots, n, isupper);
+      return result;
+    }
 
 
-        public static double determinantldlt(ref double[,] a,
-            ref int[] pivots,
-            int n,
-            bool isupper)
-        {
-            double result = 0;
-            int k = 0;
+    public static double determinantldlt(ref double[,] a,
+        ref int[] pivots,
+        int n,
+        bool isupper) {
+      double result = 0;
+      int k = 0;
 
-            result = 1;
-            if( isupper )
-            {
-                k = 1;
-                while( k<=n )
-                {
-                    if( pivots[k]>0 )
-                    {
-                        result = result*a[k,k];
-                        k = k+1;
-                    }
-                    else
-                    {
-                        result = result*(a[k,k]*a[k+1,k+1]-a[k,k+1]*a[k,k+1]);
-                        k = k+2;
-                    }
-                }
-            }
-            else
-            {
-                k = n;
-                while( k>=1 )
-                {
-                    if( pivots[k]>0 )
-                    {
-                        result = result*a[k,k];
-                        k = k-1;
-                    }
-                    else
-                    {
-                        result = result*(a[k-1,k-1]*a[k,k]-a[k,k-1]*a[k,k-1]);
-                        k = k-2;
-                    }
-                }
-            }
-            return result;
+      result = 1;
+      if (isupper) {
+        k = 1;
+        while (k <= n) {
+          if (pivots[k] > 0) {
+            result = result * a[k, k];
+            k = k + 1;
+          } else {
+            result = result * (a[k, k] * a[k + 1, k + 1] - a[k, k + 1] * a[k, k + 1]);
+            k = k + 2;
+          }
         }
+      } else {
+        k = n;
+        while (k >= 1) {
+          if (pivots[k] > 0) {
+            result = result * a[k, k];
+            k = k - 1;
+          } else {
+            result = result * (a[k - 1, k - 1] * a[k, k] - a[k, k - 1] * a[k, k - 1]);
+            k = k - 2;
+          }
+        }
+      }
+      return result;
+    }
 
 
-        public static double determinantsymmetric(double[,] a,
-            int n,
-            bool isupper)
-        {
-            double result = 0;
-            int[] pivots = new int[0];
+    public static double determinantsymmetric(double[,] a,
+        int n,
+        bool isupper) {
+      double result = 0;
+      int[] pivots = new int[0];
 
-            a = (double[,])a.Clone();
+      a = (double[,])a.Clone();
 
-            ldlt.ldltdecomposition(ref a, n, isupper, ref pivots);
-            result = determinantldlt(ref a, ref pivots, n, isupper);
-            return result;
-        }
+      ldlt.ldltdecomposition(ref a, n, isupper, ref pivots);
+      result = determinantldlt(ref a, ref pivots, n, isupper);
+      return result;
     }
+  }
 }
